//+------------------------------------------------------------------+
//|                                                      MTF_RSI.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                    29 April 2012 Yannis Alerts                   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"
#include <Pop.mqh>

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Magenta
#property indicator_style1 2
#property indicator_color2 Red//Lime
#property indicator_width2 2
#property indicator_color3 Lime//Red
#property indicator_width3 2
#property indicator_color4 Yellow
#property indicator_width4 1
#property indicator_color5 EMPTY
#property indicator_color6 EMPTY
#property indicator_color7 DeepSkyBlue
#property indicator_width7 2
#property indicator_color8 DeepSkyBlue
#property indicator_width8 2


#property indicator_minimum -5
#property indicator_maximum 105

//=================================================================================================
#property indicator_level1 95
#property indicator_level3 50
#property indicator_level2 5
#property indicator_levelcolor Red  
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 0
//=================================================================================================

extern int RSI_Period_1 = 13;
extern int RSI_Period_2 = 8 ;
extern int RSI_Period_3 = 3 ;

extern int TF1        = 5;

extern int     LineSize1 = 1;
extern int     LineSize2 = 2;
extern int     LineSize3 = 2;
extern int     DotSize1  = 2;
extern int     DotSize2  = 1;
extern int     NumberOfBars = 500; 
extern string  x______________________ = "___________________";
extern bool    Use.Alert.On.Cross      = true;//******************
extern bool    Use.Pop.MSN.Alerts      = False;
extern bool    Draw.Arrows.On.Chart    = True;
extern int     Up.Arrow.Code           = 233;//241
extern color   Up.Arrow.Color          = Gold;
extern int     Up.Arrow.Size           = 2;
extern int     Dn.Arrow.Code           = 234;//242
extern color   Dn.Arrow.Color          = Gold;
extern int     Dn.Arrow.Size           = 2;

//-------------------------------------------------------------------------------------------------
double   RSIBuffer1[];
double   RSIBuffer2[];
double   RSIBuffer3[];
double   RSIBuffer4[];
double   upX[];
double   dnX[];
double   upX2[];
double   dnX2[];
datetime alertTag;
string   signal,lastsignal;
int      iAlertCount=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    IndicatorDigits(+2);
    SetIndexStyle (0, DRAW_LINE, STYLE_DOT,1);
    SetIndexBuffer(0, RSIBuffer1);
    SetIndexStyle (1, DRAW_LINE, STYLE_SOLID,2);
    SetIndexBuffer(1, RSIBuffer2);
    SetIndexStyle (2, DRAW_LINE, STYLE_SOLID,2);
    SetIndexBuffer(2, RSIBuffer3);

    SetIndexStyle(3,DRAW_ARROW,STYLE_SOLID,1);
    SetIndexArrow(3,159);
    SetIndexBuffer(3,RSIBuffer4);
    
    SetIndexStyle(4,DRAW_ARROW,STYLE_SOLID,1);
    SetIndexArrow(4,222);
    SetIndexBuffer(4,upX);
    SetIndexStyle(5,DRAW_ARROW,STYLE_SOLID,1);
    SetIndexArrow(5,221);
    SetIndexBuffer(5,dnX);
    
    SetIndexStyle(6,DRAW_ARROW,STYLE_SOLID,1);
    SetIndexArrow(6,234);
    SetIndexBuffer(6,upX2);
    SetIndexStyle(7,DRAW_ARROW,STYLE_SOLID,1);
    SetIndexArrow(7,233);
    SetIndexBuffer(7,dnX2);
    
    string  ThisName = "RSI-M5_X3";
    string Text=ThisName;
    Text=Text+"  ("+TF1;
    Text=Text+")";
    Text=Text+"(";
    Text=Text+" "+DoubleToStr(RSI_Period_1,0);
    Text=Text+"/"+DoubleToStr(RSI_Period_2,0);
    Text=Text+"/"+DoubleToStr(RSI_Period_3,0);
    Text=Text+")  ";
    IndicatorShortName(Text); 

   switch(TF1)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }

   return(0);
}

int deinit()
{
   ClearPrevArrows();
   return(0);
}


int start()
{
   datetime TimeArray[];
   int      i,limit,y=0,counted_bars=IndicatorCounted();
   int      sh, nsb,nsb2,nsb3;

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TF1); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++;

      RSIBuffer1[i]=iRSI(NULL, TF1, RSI_Period_1, PRICE_CLOSE, y);  //14
      RSIBuffer2[i]=iRSI(NULL, TF1, RSI_Period_2, PRICE_CLOSE, y);   //5
      RSIBuffer3[i]=iRSI(NULL, TF1, RSI_Period_3, PRICE_CLOSE, y);  //2
      RSIBuffer4[i]=iRSI(NULL, TF1, RSI_Period_3, PRICE_CLOSE, y);  //DOT YELLOW

      if ((RSIBuffer3[1]>RSIBuffer2[1]) && (RSIBuffer3[2]<RSIBuffer2[2]))
      {
         if (Use.Alert.On.Cross)
         {  
            signal="Long";
            if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
            {  
               Alert ("RSI Crossing LONG ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" RSI Crossing LONG "), "C:\\");
               alertTag = Time[0];
               lastsignal=signal;
               iAlertCount++;
            }
         }
      }
      else if ((RSIBuffer3[1]<RSIBuffer2[1]) && (RSIBuffer3[2]>RSIBuffer2[2]))
      {  if (Use.Alert.On.Cross)
          {  signal="Short";
            if ((lastsignal != signal) && (alertTag!=Time[0]) && (iAlertCount==0))
            {  
               Alert ("RSI Crossing SHORT ","\n Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               if (Use.Pop.MSN.Alerts) pop ((Symbol()+" "+Period()+"min"+" RSI Crossing SHORT "), "C:\\");
               alertTag = Time[0];
               lastsignal=signal;
               iAlertCount++;
            } 
          }
      }
   }       

   for(i=600; i>=1; i--)
   {  
      if ((RSIBuffer3[i]<=RSIBuffer2[i]) && (RSIBuffer3[i+1]>RSIBuffer2[i+1]))  
      {  if (Draw.Arrows.On.Chart)
         {  ObjectCreate ("RSIShort  "+TimeToStr(Time[i]),OBJ_ARROW,0,Time[i],High[i]+2*Point);//****+10
            ObjectSet    ("RSIShort  "+TimeToStr(Time[i]),OBJPROP_ARROWCODE,Dn.Arrow.Code);
            ObjectSet    ("RSIShort  "+TimeToStr(Time[i]),OBJPROP_WIDTH,Dn.Arrow.Size);
            ObjectSet    ("RSIShort  "+TimeToStr(Time[i]),OBJPROP_COLOR,Dn.Arrow.Color);
         }
      }

      if ((RSIBuffer3[i]>=RSIBuffer2[i]) && (RSIBuffer3[i+1]<RSIBuffer2[i+1]))   
      {  if (Draw.Arrows.On.Chart)
         {  ObjectCreate ("RSILong  "+TimeToStr(Time[i]),OBJ_ARROW,0,Time[i],Low[i]-0*Point);//*****-5
            ObjectSet    ("RSILong  "+TimeToStr(Time[i]),OBJPROP_ARROWCODE,Up.Arrow.Code);
            ObjectSet    ("RSILong  "+TimeToStr(Time[i]),OBJPROP_WIDTH,Up.Arrow.Size);
            ObjectSet    ("RSILong  "+TimeToStr(Time[i]),OBJPROP_COLOR,Up.Arrow.Color);
         }
      }
   }

   return(0);

}


int ClearPrevArrows()
{
   for (int i=610; i>=0; i--)
   {  ObjectDelete ("RSIShort  "+TimeToStr(Time[i]));
      ObjectDelete ("RSILong  "+TimeToStr(Time[i]));
   }
}


